package org.apache.commons.lang3.tuple;

package .tmp;

import java.util.Map;
import org.apache.commons.lang3.tuple.Pair;

public class MutablePair<L, R> extends Pair<L, R> {
  public static final org.apache.commons.lang3.tuple.MutablePair<?, ?>[] EMPTY_ARRAY = (org.apache.commons.lang3.tuple.MutablePair<?, ?>[])new org.apache.commons.lang3.tuple.MutablePair[0];
  
  private static final long serialVersionUID = 4954918890077093841L;
  
  public L left;
  
  public R right;
  
  public static <L, R> org.apache.commons.lang3.tuple.MutablePair<L, R>[] emptyArray() {
    return (org.apache.commons.lang3.tuple.MutablePair<L, R>[])EMPTY_ARRAY;
  }
  
  public static <L, R> org.apache.commons.lang3.tuple.MutablePair<L, R> of(L left, R right) {
    return new org.apache.commons.lang3.tuple.MutablePair<>(left, right);
  }
  
  public static <L, R> org.apache.commons.lang3.tuple.MutablePair<L, R> of(Map.Entry<L, R> pair) {
    L left;
    R right;
    if (pair != null) {
      left = pair.getKey();
      right = pair.getValue();
    } else {
      left = null;
      right = null;
    } 
    return new org.apache.commons.lang3.tuple.MutablePair<>(left, right);
  }
  
  public MutablePair() {}
  
  public MutablePair(L left, R right) {
    this.left = left;
    this.right = right;
  }
  
  public L getLeft() {
    return this.left;
  }
  
  public R getRight() {
    return this.right;
  }
  
  public void setLeft(L left) {
    this.left = left;
  }
  
  public void setRight(R right) {
    this.right = right;
  }
  
  public R setValue(R value) {
    R result = getRight();
    setRight(value);
    return result;
  }
}
